"use strict";

function _typeof(obj) {
  "@babel/helpers - typeof";
  if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") {
    _typeof = function _typeof(obj) {
      return typeof obj;
    };
  } else {
    _typeof = function _typeof(obj) {
      return obj &&
        typeof Symbol === "function" &&
        obj.constructor === Symbol &&
        obj !== Symbol.prototype
        ? "symbol"
        : typeof obj;
    };
  }
  return _typeof(obj);
}

/*!
 * JSSDK-DtDream v0.0.3
 * (c) 2014-2017 DtDream
 * Released under the MIT License.
 * @update 20201209 康一
 */
(function (global, factory) {
  (typeof exports === "undefined" ? "undefined" : typeof(exports)) ===
    "object" && typeof module !== "undefined"
    ? (module.exports = factory())
    : typeof define === "function" && define.amd
    ? define(factory)
    : (global.dd = factory());
})(this, function () {
  "use strict";

  var notification = [
    {
      namespace: "device.notification.alert",
      name: "弹窗alert",
      defaultParams: {
        title: "",
        buttonName: "确定",
      },
    },
    {
      namespace: "device.notification.confirm",
      name: "弹窗confirm",
      defaultParams: {
        title: "",
        buttonLabels: ["确定", "取消"],
      },
    },
    {
      namespace: "device.notification.prompt",
      name: "弹窗prompt",
      defaultParams: {
        title: "",
        buttonLabels: ["确定", "取消"],
      },
    },
    {
      namespace: "device.notification.vibrate",
      name: "震动",
      defaultParams: {
        duration: 300,
      },
    },
    {
      namespace: "device.notification.toast",
      name: "Toast",
      defaultParams: {
        text: "toast",
        duration: 2,
      },
    },
    {
      namespace: "device.notification.showPreloader",
      name: "显示浮层",
      defaultParams: {
        text: "加载中...",
        showIcon: true,
      },
    },
    {
      namespace: "device.notification.hidePreloader",
      name: "隐藏浮层",
    },
    {
      namespace: "device.notification.actionSheet",
      name: "ActionSheet控件",
      defaultParams: {
        cancelButton: "取消",
      },
    },
    {
      namespace: "device.notification.selectImg",
      name: "图片选择",
    },
    {
      namespace: "device.notification.chooseImage",
      name: "图片上传",
    },
  ];
  var audio = [
    {
      namespace: "device.audio.startRecord",
      name: "开始录制音频",
    },
    {
      namespace: "device.audio.stopRecord",
      name: "停止录制音频",
    },
    {
      namespace: "device.audio.onRecordEnd",
      name: "监听录音自动停止",
    },
    {
      namespace: "device.audio.download",
      name: "下载音频",
    },
    {
      namespace: "device.audio.play",
      name: "播放音频",
    },
    {
      namespace: "device.audio.pause",
      name: "暂停播放音频",
    },
    {
      namespace: "device.audio.onPlayEnd",
      name: "监听播放音频停止的事件接口",
    },
    {
      namespace: "device.audio.resume",
      name: "暂停之后继续播放音频",
    },
    {
      namespace: "device.audio.stop",
      name: "停止播放音频",
    },
  ];
  var win$1 = window;
  var device = [
    {
      namespace: "device.location.get",
      name: "定位",
    },
    {
      namespace: "device.launcher.checkInstalledApps",
      name: "检测应用是否安装",
    },
    {
      namespace: "device.launcher.launchApp",
      name: "启动第三方app",
    },
    {
      namespace: "device.base.getUUID",
      name: "获取通用唯一识别码（卸载重新安装会改变）",
    },
    {
      namespace: "device.base.getSystemInfo",
      name: "获取系统信息",
      version: "1.0.0",
    },
    {
      namespace: "device.connection.getNetworkType",
      name: "获取当前网络类型",
    },
    {
      namespace: "device.accelerometer.watchShake",
      name: "启动摇一摇",
      defaultParams: {
        watch: true,
      },
      paramsCallback: function paramsCallback(params) {
        win$1.dd && win$1.dd.ios && (params.sensitivity = 3.2);
      },
    },
    {
      namespace: "device.accelerometer.clearShake",
      name: "停止摇一摇",
      defaultParams: {},
      msg: "公交",
    },
    {
      namespace: "device.screen.highlightSet",
      name: "调整屏幕亮度",
      defaultParams: {
        value: "0.5",
      },
      msg: "公交",
    },
    {
      namespace: "device.screen.highlightReset",
      name: "重置屏幕亮度",
      msg: "公交",
    },
  ];
  device = [].concat(device, notification, audio);
  var device$1 = device;
  var util = [
    {
      namespace: "biz.util.selectLocalCity",
      name: "获取当前所在城市的信息",
      defaultParams: {
        cityId: "419900",
        cityName: "省本级",
      },
    },
    {
      namespace: "biz.util.scan",
      name: "扫码(支持二维码和条形码)",
      defaultParams: {
        type: "qrCode",
      },
    },
    {
      namespace: "biz.util.share",
      name: "分享",
    },
    {
      namespace: "biz.util.pay",
      name: "支付",
    },
    {
      namespace: "biz.util.request",
      name: "请求代理",
      defaultParams: {
        method: "GET",
      },
    },
    {
      namespace: "biz.util.openLink",
      name: "新开页面",
    },
  ];
  var navigation = [
    {
      namespace: "biz.navigation.setTitle",
      name: "设置导航栏标题",
    },
    {
      namespace: "biz.navigation.show",
      name: "显示导航栏",
    },
    {
      namespace: "biz.navigation.setVisible",
      name: "隐藏导航栏",
      version: "1.0.0",
    },
    {
      namespace: "biz.navigation.close",
      name: "关闭webview",
    },
    {
      namespace: "biz.navigation.setSegmentedTitle",
      name: "设置切换分段控制器",
    },
    {
      namespace: "biz.navigation.setLeft",
      name: "设置导航左侧按钮",
      version: "1.0.0",
      defaultParams: {
        hander: function hander() {
          window.location.go(-1);
        },
      },
    },
    {
      namespace: "biz.navigation.setRightBtn",
      name: "设置导航右侧按钮文字",
      defaultParams: {
        show: true,
        control: false,
        text: "",
      },
    },
    {
      namespace: "biz.navigation.setRight",
      name: "设置导航右侧按钮文字",
      message: "公交",
      defaultParams: {
        show: true,
        control: false,
        text: "",
      },
    },
    {
      namespace: "biz.navigation.setMenu",
      name: "设置导航左侧按钮",
      defaultParams: {
        backgroundColor: "#FF000000",
      },
    },
  ];
  var biz = [
    {
      namespace: "biz.telephone.call",
      name: "打电话",
    },
    {
      namespace: "biz.telephone.sms",
      name: "发短信",
    },
    {
      namespace: "biz.user.checkLogin",
      name: "检查是否登录",
    },
    {
      namespace: "biz.map.getLocation",
      name: "获取当前地理位置",
      msg: "公交",
    },
    {
      namespace: "biz.user.get",
      name: "获取用户token",
      msg: "公交",
    },
    {
      namespace: "biz.user.getAlipayInfo",
      name: "支付宝授权获取Alipayid",
      msg: "公交",
      version: "1.0.0",
    },
    {
      namespace: "biz.user.authAlipay",
      name: "获取用户authAlipay",
      msg: "公交",
      version: "1.0.0",
    },
    {
      namespace: "biz.controller.push",
      name: "跳转指定控制器",
      msg: "公交",
    },
    {
      namespace: "biz.map.getLocation",
      name: "获取App当前经纬度",
      msg: "公交",
    },
    {
      namespace: "biz.map.goMetroStation",
      name: "选中去某个地铁站",
      msg: "地铁",
    },
    {
      namespace: "biz.map.goTransfer",
      name: "选择地铁站起点和终点",
      msg: "地铁",
    },
    {
      namespace: "biz.user.get",
      name: "通用JSAPI接口获取用户信息",
      msg: "公交",
    },
    {
      namespace: "biz.map.navigation",
      name: "地图导航",
      msg: "公交",
    },
    {
      namespace: "biz.order.alipay",
      name: "获取阿里支付订单信息",
      msg: "公交",
    },
    {
      namespace: "biz.order.wxMini",
      name: "跳转微信小程序",
      msg: "公交",
    },
    {
      namespace: "biz.order.wxPay",
      name: "微信支付",
      msg: "公交",
    },
    {
      namespace: "biz.order.nativeAliPay",
      name: "支付宝支付支付",
      msg: "公交",
    },
  ];
  var biz$1 = [].concat(biz, util, navigation);
  var util$2 = [
    {
      namespace: "util.localStorage.getItem",
      name: "本地存储, 获取",
    },
    {
      namespace: "util.localStorage.setItem",
      name: "本地存储, 设置",
    },
    {
      namespace: "util.localStorage.removeItem",
      name: "本地存储, 删除",
    },
  ];
  var methods = {
    device: device$1,
    biz: biz$1,
    util: util$2,
    ui: [
      {
        namespace: "ui.input.plain",
        name: "输入框（单行）",
      },
      {
        namespace: "ui.webViewBounce.enable",
        name: "启用webview下拉弹性效果",
      },
      {
        namespace: "ui.webViewBounce.disable",
        name: "禁用webview下拉弹性效果",
      },
      {
        namespace: "ui.pullToRefresh.enable",
        name: "启用下拉刷新",
      },
      {
        namespace: "ui.pullToRefresh.stop",
        name: "停止下拉刷新",
      },
      {
        namespace: "ui.pullToRefresh.disable",
        name: "禁用下拉刷新",
      },
    ],
  };

  function getMethodInfo(namespace) {
    if (get(dd, "namespace")) {
      return null;
    }

    var methodGroupName = namespace.split(".")[0];
    var methodGroup = get(dd, "methods." + methodGroupName, []);

    for (var index = 0; index < methodGroup.length; index++) {
      var methodInfo = methodGroup[index];

      if (methodInfo.namespace === namespace) {
        return methodInfo;
      }
    }
  }
  /**
   * 将命名空间的string转化为嵌套对象, 并将方法执行体挂载最后
   * @param {object} dd - dd对象树
   * @param {string} namespace - 命名空间: 'device.notification.alert'
   * @param {function} methodHandler - 方法的执行函数: alert的执行方法
   *
   * @description
   * 'device.notification.alert' -> dd:{device:{notification:{alert:methodHandler}}}
   */

  function namespaceToObjectTree(dd, namespace, methodHandler) {
    var _dd = dd;
    var namespaceArr = namespace.split("."); // ["device", "notification", "alert"]

    var i, length;

    for (i = 0, length = namespaceArr.length; i < length; i++) {
      if (i === length - 1) {
        // 最后一个时 alert, 挂载函数方法
        _dd[namespaceArr[i]] = methodHandler;
      }

      if (!_dd[namespaceArr[i]]) {
        _dd[namespaceArr[i]] = {};
      }

      _dd = _dd[namespaceArr[i]];
    }

    return _dd;
  }

  function extend(dist, source) {
    if (source) {
      for (var key in source) {
        dist[key] = source[key];
      }
    }

    return dist;
  }

  var win$2 = window;
  /**
   * bridge方法的执行器
   *
   * @param {string} namespace - 命名空间, 比如: 'device.notification.alert'
   * @param {object} extraParams - 额外参数
   * @param {object} namespaceInfo - 当前命名空间的参数信息, 比如: 'device.notification.alert'
   * @param {object} namespaceInfo.namespace - 命名空间, 比如: 'device.notification.alert'
   * @param {object} namespaceInfo.name - 命名空间, 比如: '弹窗alert'
   * @param {object} namespaceInfo.ios - ios版本, 比如: '2.4.0'
   * @param {object} namespaceInfo.android - 安卓版本, 比如: '2.4.0'
   * @param {object} namespaceInfo.defaultParams - 默认参数
   */

  function webViewJavascriptBridgeExecutor(
    namespace,
    extraParams,
    namespaceInfo
  ) {
    if ("undefined" === typeof win$2.WebViewJavascriptBridge) {
      debug("Variable [win.WebViewJavascriptBridge] does not exist!");
      return false;
    }

    var params = {}; // 当前方法的参数

    params = extend(params, namespaceInfo && namespaceInfo.defaultParams);
    extend(params, extraParams); // 参数过滤

    namespaceInfo &&
      namespaceInfo.paramsCallback &&
      namespaceInfo.paramsCallback(params);

    var onSuccess = function onSuccess(result) {
      debug("Default success callback " + namespace + " " + result);
    };

    var onFail = function onFail(result) {
      debug("Default failure callback " + namespace + " " + result);
    };

    var onCancel = function onCancel(result) {
      debug("Default cancel callback " + namespace + " " + result);
    };

    if (params.onSuccess) {
      onSuccess = params.onSuccess;
      delete params.onSuccess;
    }

    if (params.onFail) {
      onFail = params.onFail;
      delete params.onFail;
    }

    if (params.onCancel) {
      onCancel = params.onCancel;
      delete params.onCancel;
    }
    /**
     * 响应结果兜底
     * @param {string} data - 响应对象的string, 需要自己JSON.parse
     * @param {object} data.errorCode - errorCode
     * @param {object} data.errorMessage - errorMessage
     * @param {object} data.result - result
     */

    var responseHandler = function responseHandler(data) {
      console.info("App\u8FD4\u56DE\u7ED3\u679C: " + data);
      console.info("App\u8FD4\u56DE\u7ED3\u679C: " + JSON.stringify(data));

      try {
        var response = JSON.parse(data);
        var errorCode = response.errorCode;
        var errorMessage = response.errorMessage;
        var result = response.result;

        if ("0" === errorCode) {
          onSuccess && onSuccess.call(null, result);
        } else if ("-1" === errorCode) {
          onCancel && onCancel.call(null, result);
        } else {
          onFail && onFail.call(null, errorMessage, errorCode);
        }
      } catch (err) {
        console.error("JSON.parse Error in responseHandler from app retruns");
        onFail && onFail.call(null, "ResponseHandler: JSON.parse Error!");
      }
    };

    var watch = params.watch;
    var handleData = {
      handlerName: namespace,
      params: params,
    };
    debug("开始执行 webViewJavascriptBridgeExecutor");
    debug("\u4F20\u5165\u6570\u636E: " + JSON.stringify(handleData));

    if (watch) {
      win$2.WebViewJavascriptBridge &&
        win$2.WebViewJavascriptBridge.registerHandler(
          namespace,
          function (data, callback) {
            responseHandler(data);
            callback &&
              callback({
                errorCode: "0",
                errorMessage: "成功",
              });
          }
        );
      win$2.WebViewJavascriptBridge &&
        win$2.WebViewJavascriptBridge.callHandler(
          "dd.native.call",
          handleData,
          responseHandler
        );
    } else {
      win$2.WebViewJavascriptBridge &&
        win$2.WebViewJavascriptBridge.callHandler(
          "dd.native.call",
          handleData,
          responseHandler
        );
    }
  }
  /**
   * methodExecutor
   * @description
   * 如果当前环境中有 promise 则返回promise结果
   * @param {string} namespace - 命名空间: 'device.notification.alert'
   * @param {object} params - 外部参数
   * @param {object} namespaceInfo - 命名空间对象
   */

  function methodExecutor(namespace, params, namespaceInfo) {
    webViewJavascriptBridgeExecutor(namespace, params, namespaceInfo);
  } // Import here Polyfills if needed. Recommended core-js (npm i -D core-js)
  // import "core-js/fn/array.find"
  // ...

  var win = window;
  var userAgent = win.navigator.userAgent;
  var sdkVersion = "0.0.2";
  var isInit = false;
  var versions = userAgent.match(/dtdream\(\w+\/([a-zA-Z0-9.-]+)\)/);
  var version = versions ? versions[1] : "";
  var appUaArr = ["dtpublictransitweb", "ibuscloud.*web"];
  var dd = {
    ios: /iPhone|iPad|iPod/i.test(userAgent),
    android: /Android/i.test(userAgent),
    dtdream: /dtdream/i.test(userAgent),
    ibusApp: new RegExp("(".concat(appUaArr.join("|"), ")"), "i").test(
      userAgent
    ),
    version: version,
    type: function type(e) {
      return Object.prototype.toString.call(e).match(/^\[object\s(.*)\]$/)[1];
    },
    sdk_version: sdkVersion,
    methods: methods,
    config: {
      debug: true,
    },
    error: function error(callbacks) {
      if (callbacks === void 0) {
        callbacks = noop;
      }

      debug("error");
    },
    ready: function ready(callbacks) {
      // Ensure errorCallback is configured correctly
      win.setTimeout(function () {
        if (!dd.dtdream) {
          isInit = false;
          return debug("Please open this page in DtDream App!");
        }

        var execute = function execute(JavascriptBridge) {
          if (!JavascriptBridge) return debug("bridge init failure!");
          callbacks && callbacks.apply(null, JavascriptBridge);
          isInit = true;
        };

        if (win.WebViewJavascriptBridge) {
          execute(win.WebViewJavascriptBridge);
        } else {
          document.addEventListener(
            "WebViewJavascriptBridgeReady",
            function () {
              if (!isInit) {
                execute(win.WebViewJavascriptBridge);
              }
            },
            false
          );
          setupWebViewJavascriptBridge(function () {
            if ("undefined" === typeof win.WebViewJavascriptBridge) {
              return debug("Please open this page in DtDream App!!");
            }

            if (!isInit) {
              execute(win.WebViewJavascriptBridge);
            }
          });
        }
      }, 0);
    },
    compareVersion: function compareVersion(
      leftVersion,
      rightVersion,
      include
    ) {
      if ("string" !== typeof leftVersion || "string" !== typeof rightVersion) {
        return false;
      }

      if (include && leftVersion === rightVersion) {
        return true;
      }

      return isNewVersion(leftVersion, rightVersion);
    },
  }; // The methods in methods are generated to access objects

  if (dd.methods) {
    for (var classify in dd.methods) {
      if (classify && dd.methods[classify]) {
        dd.methods[classify].forEach(function (namespaceInfo) {
          namespaceToObjectTree(
            dd,
            namespaceInfo.namespace,
            function (extraParams) {
              return methodExecutor(
                namespaceInfo.namespace,
                extraParams,
                namespaceInfo
              );
            }
          );
        });
      }
    }
  } // Manual to mount WebViewJavascriptBridge

  function setupWebViewJavascriptBridge(callback) {
    if (callback === void 0) {
      callback = noop;
    }

    win.WVJBCallbacks = [noop];
    var WVJBIframe = document.createElement("iframe");
    WVJBIframe.style.display = "none";
    WVJBIframe.src = "ddjsscheme://__bridge_loaded__";
    document.documentElement.appendChild(WVJBIframe);
    win.setTimeout(function () {
      document.documentElement.removeChild(WVJBIframe);
      callback && callback(win.WebViewJavascriptBridge);
    }, 0);
  } // You need to manually notify the app to mount WebViewJavascriptBridge objects

  setupWebViewJavascriptBridge(function () {
    var getDeviceSystemInfo = get(dd, "device.base.getSystemInfo");
    var deviceSystemInfo = null;

    var checkVersion = function checkVersion(_deviceSystemInfo, fnInfo) {
      var calledFnMinimumVersion = fnInfo.version;
      var curentVersion = _deviceSystemInfo.sdkVersion || "0.0.0";
      return dd.compareVersion(calledFnMinimumVersion, curentVersion, true);
    }; // 初始化 立即获取一次app数据

    getDeviceSystemInfo({
      onSuccess: function onSuccess(info) {
        debug("appSystemInfo", info);
        deviceSystemInfo = info;
      },
    });

    dd.canIUse = function (namespace, argCb) {
      var cb = argCb || noop;
      var fnInfo = getMethodInfo(namespace);
      var result = false; // 失败, 不存在这个方法

      if (!fnInfo) {
        cb(false);
        return;
      } // 没有version值或没有getDeviceSystemInfo方法时，为已前初始的版本, 默认假设有这个方法

      if (!fnInfo.version || !getDeviceSystemInfo) {
        cb(false);
        return;
      } else if (deviceSystemInfo) {
        var result = checkVersion(deviceSystemInfo, fnInfo);
        cb(result);
      } else {
        var timer = setTimeout(function () {
          cb(false);
        }, 300);
        getDeviceSystemInfo({
          onSuccess: function onSuccess(info) {
            deviceSystemInfo = info;
            var result = checkVersion(deviceSystemInfo, fnInfo);

            if (timer) {
              clearTimeout(timer);
              cb(result);
            }
          },
        });
      }
    };
  }); // Global, you have to put it here

  // utils
  function _toConsumableArray(arr) {
    return (
      _arrayWithoutHoles(arr) ||
      _iterableToArray(arr) ||
      _unsupportedIterableToArray(arr) ||
      _nonIterableSpread()
    );
  }

  function _nonIterableSpread() {
    throw new TypeError(
      "Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."
    );
  }

  function _unsupportedIterableToArray(o, minLen) {
    if (!o) return;
    if (typeof o === "string") return _arrayLikeToArray(o, minLen);
    var n = Object.prototype.toString.call(o).slice(8, -1);
    if (n === "Object" && o.constructor) n = o.constructor.name;
    if (n === "Map" || n === "Set") return Array.from(o);
    if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))
      return _arrayLikeToArray(o, minLen);
  }

  function _iterableToArray(iter) {
    if (typeof Symbol !== "undefined" && Symbol.iterator in Object(iter))
      return Array.from(iter);
  }

  function _arrayWithoutHoles(arr) {
    if (Array.isArray(arr)) return _arrayLikeToArray(arr);
  }

  function _arrayLikeToArray(arr, len) {
    if (len == null || len > arr.length) len = arr.length;

    for (var i = 0, arr2 = new Array(len); i < len; i++) {
      arr2[i] = arr[i];
    }

    return arr2;
  }

  function isNewVersion(oldStr, newStr) {
    var contrastIdx =
      arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : 0;
    var oldArr = [0, 0, 0];
    var newArr = [0, 0, 0];
    oldArr.splice.apply(
      oldArr,
      [0, oldStr.split(".").length].concat(
        _toConsumableArray(oldStr.split("."))
      )
    );
    newArr.splice.apply(
      newArr,
      [0, newStr.split(".").length].concat(
        _toConsumableArray(newStr.split("."))
      )
    );
    var oldTag = parseInt(newArr[contrastIdx], 10);
    var newTag = parseInt(oldArr[contrastIdx], 10);

    if (oldTag === newTag) {
      if (contrastIdx === 2) {
        return false;
      }

      return isNewVersion(oldStr, newStr, contrastIdx + 1);
    } else if (oldTag < newTag) {
      return false;
    }

    return true;
  }
  /**
   * debug
   * @param {string} message - debug message
   */

  function debug(message, a, b, c, d) {
    var win = window;
    var debug = !!win.dd && !!win.dd.config && !!win.dd.config.debug;

    if (debug) {
      var log = window.console.log;
      var args = ["[jsBridge]:", message, a, b, c, d].filter(function (i) {
        return i;
      });
      log.apply(window.console, args);
    }
  }
  /**
   * get lodash like
   * @param {*} obj
   * @param {*} path
   * @param {*} def
   */
  function get(obj, path, def) {
    var fullPath = path
      .replace(/\[/g, ".")
      .replace(/]/g, "")
      .split(".")
      .filter(Boolean);
    return fullPath.every(function (step) {
      return !(step && (obj = obj[step]) === undefined);
    })
      ? obj
      : def;
  }

  function noop() {}

  win.dd = dd;
  return dd;
});
